# DeviceRegistrations resource

> \[!IMPORTANT]
>
> The Push Notifications API is currently available as a
> Private Beta product. The information contained in this document is subject to change. You acknowledge
> and agree that your use of the Twilio Push Notifications API is subject to the terms of the [Services in
> Private Beta](https://www.twilio.com/en-us/legal/service-country-specific-terms/private-beta). This
> means that some features are not yet implemented and others may be changed before the product is
> declared as Generally Available. Private Beta products are not covered by the Twilio Support Terms or
> Twilio Service Level Agreement.

A Device Registration resource associates a device token with a [User](/docs/push-notifications/api/user-resource) for push notification delivery. Instead of managing device tokens yourself, you can store them as Device Registrations and send notifications to Users by their `userId`.

Each Device Registration links a `userId` to a device `token` and `provider` (`APN` or `FCM`), scoped to a specific [App](/docs/push-notifications/api/app-resource).

## DeviceRegistration Properties

<OperationTable type="properties" data={{"x-twilio-version":1,"title":"DeviceRegistration","type":"object","description":"A registration is a collection of a User's devices registered under a single app. It is uniquely identified by the combination of the User's id and the app name. A device is a physical device or a browser that can receive push notifications. A device is uniquely identified by its app-specific unique token and the push provider identifier.","required":["id","appName","userId","devices","related"],"refName":"DeviceRegistration","modelName":"DeviceRegistration","properties":{"id":{"x-twilio-version":1,"title":"DeviceRegistrationId","description":"A reference to a Device Registration.","type":"string","pattern":"^comms_device_registration_[a-hjkmnpqrstv-z0-9]{26,34}$","example":"comms_device_registration_01h9krwprkeee8fzqspvwy6nq8","refName":"DeviceRegistrationId","modelName":""},"appName":{"type":"string","description":"The name of the `App` that the device registrations are for."},"userId":{"x-twilio-version":1,"title":"PushNotificationUserId","description":"A reference to a Push Notification User.","type":"string","pattern":"^comms_pushnotificationuser_[0-7][a-hjkmnpqrstv-z0-9]{25,34}","example":"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8","refName":"PushNotificationUserId","modelName":""},"devices":{"type":"array","minItems":1,"maxItems":50,"description":"List of devices registered in this set.","items":{"x-twilio-version":1,"title":"Device","type":"object","description":"A device is a physical device or a browser that can receive push notifications. A device is uniquely identified by its app-specific unique token and the push provider identifier.","required":["token","provider"],"refName":"Device","modelName":"Device","properties":{"token":{"type":"string","description":"Push notifications token for the device/browser."},"provider":{"x-twilio-version":1,"title":"PushNotificationProvider","description":"Push notification service provider.","type":"string","enum":["APN","FCM"],"refName":"PushNotificationProvider","modelName":"PushNotificationProvider"}}}},"related":{"description":"A list of resources that are associated with this Device Registration.","type":"array","items":{"x-twilio-version":1,"title":"RelatedResource","type":"object","description":"A reference to a related resource.","refName":"RelatedResource","modelName":"RelatedResource","properties":{"name":{"type":"string","description":"The name of the related resource.","enum":["EMAIL","MESSAGE","PUSH_NOTIFICATION","SESSION","MEDIA","SENDER","SENDER_POOL","OPERATION","ENGAGEMENT","CREDENTIAL","PUSH_NOTIFICATION_APP","PUSH_NOTIFICATION_USER","DEVICE_REGISTRATION"]},"id":{"description":"The identifier of the related resource.","type":"string"},"uri":{"description":"The path to the related resource.","type":"string"}}}}}}} />

## Register a Device

`POST https://comms.twilio.com/v1/PushNotifications/DeviceRegistrations`

Register a device for push notifications by making an HTTP `POST` request to the Device Registrations resource URI.

You must specify an `appName` that matches an existing [App](/docs/push-notifications/api/app-resource). If the `appName` does not match any existing App, the operation fails.

If you omit the `userId`, the API creates a new [User](/docs/push-notifications/api/user-resource) automatically.

### Request body parameters

```json
{"schema":{"title":"DeviceRegistrationRequest","type":"object","required":["appName","token","provider"],"properties":{"userId":{"x-twilio-version":1,"description":"The ID of the User to register the device to, if available.","title":"PushNotificationUserId","type":"string","pattern":"^comms_pushnotificationuser_[0-7][a-hjkmnpqrstv-z0-9]{25,34}","example":"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8","refName":"PushNotificationUserId","modelName":""},"appName":{"description":"The name of the `App` to register the device for.\n\nIf the `appName` does not match the name \n  of any existing Push Notification `App`, the operation will fail.","x-twilio-version":1,"title":"PushNotificationAppName","type":"string","pattern":"^[a-z0-9_]+$","minLength":1,"maxLength":64,"refName":"PushNotificationAppName","modelName":""},"token":{"type":"string","description":"The device token to register for push notifications."},"provider":{"x-twilio-version":1,"title":"PushNotificationProvider","description":"Push notification service provider.","type":"string","enum":["APN","FCM"],"refName":"PushNotificationProvider","modelName":"PushNotificationProvider"}}},"examples":{"ExistingUser":{"x-twilio-version":1,"summary":"Existing user","value":{"lang":"json","value":"{\n  \"userId\": \"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\",\n  \"token\": \"dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh\",\n  \"appName\": \"limonade_app\",\n  \"provider\": \"FCM\"\n}","meta":"","code":"{\n  \"userId\": \"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\",\n  \"token\": \"dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh\",\n  \"appName\": \"limonade_app\",\n  \"provider\": \"FCM\"\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"userId\"","#7EE787"],[":","#C9D1D9"]," ",["\"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\"","#A5D6FF"],[",","#C9D1D9"],"\n  ",["\"token\"","#7EE787"],[":","#C9D1D9"]," ",["\"dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh\"","#A5D6FF"],[",","#C9D1D9"],"\n  ",["\"appName\"","#7EE787"],[":","#C9D1D9"]," ",["\"limonade_app\"","#A5D6FF"],[",","#C9D1D9"],"\n  ",["\"provider\"","#7EE787"],[":","#C9D1D9"]," ",["\"FCM\"","#A5D6FF"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}},"NewUser":{"x-twilio-version":1,"summary":"New User","value":{"lang":"json","value":"{\n  \"token\": \"dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh\",\n  \"appName\": \"limonade_app\",\n  \"provider\": \"FCM\"\n}","meta":"","code":"{\n  \"token\": \"dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh\",\n  \"appName\": \"limonade_app\",\n  \"provider\": \"FCM\"\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"token\"","#7EE787"],[":","#C9D1D9"]," ",["\"dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh\"","#A5D6FF"],[",","#C9D1D9"],"\n  ",["\"appName\"","#7EE787"],[":","#C9D1D9"]," ",["\"limonade_app\"","#A5D6FF"],[",","#C9D1D9"],"\n  ",["\"provider\"","#7EE787"],[":","#C9D1D9"]," ",["\"FCM\"","#A5D6FF"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}},"encodingType":"application/json","conditionalParameterMap":{}}
```

### Responses

<OperationResponse responses={[{"responseCode":"202","schema":{"x-twilio-version":1,"description":"The request was accepted and a resource ID is available to check the result. The response body contains the resource ID and link to the resource.","headers":{"Location":{"x-twilio-version":1,"schema":{"x-twilio-version":1,"type":"string","format":"uri","description":"The location (uri) of the resource identified by `Resource-Id`.","refName":"ResourceLocation","modelName":""},"description":"The location (uri) of the resource identified by `Resource-Id`."}},"content":{"application/json":{"schema":{"title":"Http202ResponseWithResourceBody","description":"Response body for HTTP 202 response with Resource data.","type":"object","required":["resourceId","resourceLocation"],"refName":"Http202ResponseWithResourceBody","modelName":"Http202ResponseWithResourceBody","properties":{"resourceId":{"x-twilio-version":1,"type":"string","description":"The Resource ID is an identifier for the resource that was created or updated\n  in response to the request.","refName":"ResourceId","modelName":""},"resourceLocation":{"x-twilio-version":1,"type":"string","format":"uri","description":"The location (uri) of the resource identified by `Resource-Id`.","refName":"ResourceLocation","modelName":""}}},"examples":{"CreateDeviceRegistrationAccepted":{"summary":"Register Device for Push Notifications request accepted","x-twilio-version":1,"value":{"lang":"json","value":"{\n  \"resourceId\": \"comms_device_registration_01h9krwprkeee8fzqspvwy6nq8\",\n  \"resourceLocation\": \"https://comms.twilio.com/v1/PushNotifications/DeviceRegistrations/comms_device_registration_01h9krwprkeee8fzqspvwy6nq8\"\n}","meta":"","code":"{\n  \"resourceId\": \"comms_device_registration_01h9krwprkeee8fzqspvwy6nq8\",\n  \"resourceLocation\": \"https://comms.twilio.com/v1/PushNotifications/DeviceRegistrations/comms_device_registration_01h9krwprkeee8fzqspvwy6nq8\"\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"resourceId\"","#7EE787"],[":","#C9D1D9"]," ",["\"comms_device_registration_01h9krwprkeee8fzqspvwy6nq8\"","#A5D6FF"],[",","#C9D1D9"],"\n  ",["\"resourceLocation\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://comms.twilio.com/v1/PushNotifications/DeviceRegistrations/comms_device_registration_01h9krwprkeee8fzqspvwy6nq8\"","#A5D6FF"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}}}},{"responseCode":"400","schema":{"x-twilio-version":1,"description":"This error indicates that the request content was malformed or ambiguous.","content":{"application/json":{"schema":{"x-twilio-version":1,"title":"TwilioErrors","type":"object","required":["errors"],"example":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21614","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The address specified in the request is not a valid phone number.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21614\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.to[0].address\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21617","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The concatenated message text exceeds the 1600 character limit\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21617\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.content.text\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}},"refName":"TwilioErrors","modelName":"TwilioErrors","properties":{"errors":{"description":"A list of one or more Twilio API errors.","type":"array","items":{"x-twilio-version":1,"title":"TwilioError","type":"object","description":"A generic error object communicating client and server side API errors.","required":["code","message","infoUrl","context"],"example":{"code":21614,"message":"The address specified in the request is not a valid phone number.","infoUrl":"https://www.twilio.com/docs/api/errors/21614","context":"$.to[0].address"},"refName":"TwilioError","modelName":"TwilioError","properties":{"code":{"type":"integer","description":"The Twilio error code."},"message":{"type":"string","description":"A human readable message describing the error."},"infoUrl":{"type":"string","format":"uri","description":"A URL to a [Twilio error directory](https://www.twilio.com/docs/api/errors) page with more information about the error code."},"context":{"description":"A JSON path that identifies the errant field.","type":["string","null"]}}}}}},"examples":{"ResourceNotFound":{"summary":"Resource not found","value":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 20404,\n      \"message\": \"Not Found\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20404\",\n      \"context\": \"null\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 20404,\n      \"message\": \"Not Found\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20404\",\n      \"context\": \"null\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["20404","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"Not Found\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/20404\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"null\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}},"refName":"#/components/responses/Http400Response","modelName":"__components_responses_Http400Response"}},{"responseCode":"429","schema":{"x-twilio-version":1,"description":"This error indicates that you have sent too many requests to the API. You should retry according to the `Retry-After` response header.","content":{"application/json":{"schema":{"x-twilio-version":1,"title":"TwilioErrors","type":"object","required":["errors"],"example":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21614","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The address specified in the request is not a valid phone number.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21614\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.to[0].address\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21617","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The concatenated message text exceeds the 1600 character limit\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21617\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.content.text\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}},"refName":"TwilioErrors","modelName":"TwilioErrors","properties":{"errors":{"description":"A list of one or more Twilio API errors.","type":"array","items":{"x-twilio-version":1,"title":"TwilioError","type":"object","description":"A generic error object communicating client and server side API errors.","required":["code","message","infoUrl","context"],"example":{"code":21614,"message":"The address specified in the request is not a valid phone number.","infoUrl":"https://www.twilio.com/docs/api/errors/21614","context":"$.to[0].address"},"refName":"TwilioError","modelName":"TwilioError","properties":{"code":{"type":"integer","description":"The Twilio error code."},"message":{"type":"string","description":"A human readable message describing the error."},"infoUrl":{"type":"string","format":"uri","description":"A URL to a [Twilio error directory](https://www.twilio.com/docs/api/errors) page with more information about the error code."},"context":{"description":"A JSON path that identifies the errant field.","type":["string","null"]}}}}}},"examples":{"TooManyRequests":{"summary":"Too Many Requests","value":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 20429,\n      \"message\": \"Too many requests. Please retry according to the Retry-After response header.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20429\",\n      \"context\": \"null\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 20429,\n      \"message\": \"Too many requests. Please retry according to the Retry-After response header.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20429\",\n      \"context\": \"null\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["20429","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"Too many requests. Please retry according to the Retry-After response header.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/20429\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"null\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}},"headers":{"Retry-After":{"schema":{"type":"string"},"description":"The amount of time in seconds that the customer should wait before issuing a new request towards the API."}},"refName":"#/components/responses/Http429Response","modelName":"__components_responses_Http429Response"}},{"responseCode":"500","schema":{"x-twilio-version":1,"description":"This error indicates that the Twilio API is experiencing server-side issues. The request should not be retried.","content":{"application/json":{"schema":{"x-twilio-version":1,"title":"TwilioErrors","type":"object","required":["errors"],"example":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21614","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The address specified in the request is not a valid phone number.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21614\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.to[0].address\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21617","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The concatenated message text exceeds the 1600 character limit\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21617\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.content.text\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}},"refName":"TwilioErrors","modelName":"TwilioErrors","properties":{"errors":{"description":"A list of one or more Twilio API errors.","type":"array","items":{"x-twilio-version":1,"title":"TwilioError","type":"object","description":"A generic error object communicating client and server side API errors.","required":["code","message","infoUrl","context"],"example":{"code":21614,"message":"The address specified in the request is not a valid phone number.","infoUrl":"https://www.twilio.com/docs/api/errors/21614","context":"$.to[0].address"},"refName":"TwilioError","modelName":"TwilioError","properties":{"code":{"type":"integer","description":"The Twilio error code."},"message":{"type":"string","description":"A human readable message describing the error."},"infoUrl":{"type":"string","format":"uri","description":"A URL to a [Twilio error directory](https://www.twilio.com/docs/api/errors) page with more information about the error code."},"context":{"description":"A JSON path that identifies the errant field.","type":["string","null"]}}}}}},"examples":{"InternalServerError":{"summary":"Internal Server Error","value":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 20500,\n      \"message\": \"Internal server error.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20500\",\n      \"context\": \"null\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 20500,\n      \"message\": \"Internal server error.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20500\",\n      \"context\": \"null\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["20500","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"Internal server error.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/20500\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"null\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}},"refName":"#/components/responses/Http500Response","modelName":"__components_responses_Http500Response"}},{"responseCode":"503","schema":{"x-twilio-version":1,"description":"This error indicates that the Twilio API is temporarily unavailable.  You should retry according to the `Retry-After` response header.","content":{"application/json":{"schema":{"x-twilio-version":1,"title":"TwilioErrors","type":"object","required":["errors"],"example":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21614","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The address specified in the request is not a valid phone number.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21614\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.to[0].address\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21617","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The concatenated message text exceeds the 1600 character limit\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21617\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.content.text\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}},"refName":"TwilioErrors","modelName":"TwilioErrors","properties":{"errors":{"description":"A list of one or more Twilio API errors.","type":"array","items":{"x-twilio-version":1,"title":"TwilioError","type":"object","description":"A generic error object communicating client and server side API errors.","required":["code","message","infoUrl","context"],"example":{"code":21614,"message":"The address specified in the request is not a valid phone number.","infoUrl":"https://www.twilio.com/docs/api/errors/21614","context":"$.to[0].address"},"refName":"TwilioError","modelName":"TwilioError","properties":{"code":{"type":"integer","description":"The Twilio error code."},"message":{"type":"string","description":"A human readable message describing the error."},"infoUrl":{"type":"string","format":"uri","description":"A URL to a [Twilio error directory](https://www.twilio.com/docs/api/errors) page with more information about the error code."},"context":{"description":"A JSON path that identifies the errant field.","type":["string","null"]}}}}}},"examples":{"ServiceUnavailable":{"summary":"Service Unavailable","value":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 20503,\n      \"message\": \"Service unavailable.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20503\",\n      \"context\": \"null\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 20503,\n      \"message\": \"Service unavailable.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20503\",\n      \"context\": \"null\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["20503","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"Service unavailable.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/20503\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"null\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}},"headers":{"Retry-After":{"schema":{"type":"string"},"description":"The amount of time in seconds that the customer should wait before issuing a new request towards the API."}},"refName":"#/components/responses/Http503Response","modelName":"__components_responses_Http503Response"}}]} path="https://comms.twilio.com/v1/PushNotifications/DeviceRegistrations" method="post" specType="comms" />

Create a DeviceRegistration

```ts
import { TwilioClient } from "twilio-comms";

async function main() {
    const client = new TwilioClient({
        accountId: "<username>",
        authToken: "<password>",
    });
    await client.pushNotifications.deviceRegistrations.register({
        userId: "comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8",
        appName: "limonade_app",
        token: "dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh",
        provider: "FCM",
    });
}
main();
```

```py
from twilio import TwilioComms

client = TwilioComms(
    account_id="<username>",
    auth_token="<password>",
)

client.push_notifications.device_registrations.register(
    user_id="comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8",
    app_name="limonade_app",
    token="dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh",
    provider="FCM",
)
```

```cs
using TwilioComms;
using System.Threading.Tasks;
using TwilioComms.PushNotifications;

public partial class Examples
{
    public async Task Example() {
        var client = new TwilioCommsClient(
            accountId: "<username>",
            authToken: "<password>"
        );

        await client.PushNotifications.DeviceRegistrations.RegisterAsync(
            new DeviceRegistrationsRegisterRequest {
                UserId = "comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8",
                AppName = "limonade_app",
                Token = "dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh",
                Provider = PushNotificationProvider.Fcm
            }
        );
    }

}
```

```java
package com.example.usage;

import com.twilio.comms.TwilioCommsClient;
import com.twilio.comms.resources.pushnotifications.deviceregistrations.requests.DeviceRegistrationsRegisterRequest;
import com.twilio.comms.types.PushNotificationProvider;

public class Example {
    public static void main(String[] args) {
        TwilioCommsClient client = TwilioCommsClient
            .builder()
            .credentials("<username>", "<password>")
            .build();

        client.pushNotifications().deviceRegistrations().register(
            DeviceRegistrationsRegisterRequest
                .builder()
                .appName("limonade_app")
                .token("dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh")
                .provider(PushNotificationProvider.FCM)
                .userId("comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8")
                .build()
        );
    }
}
```

```go
package example

import (
    context "context"

    twiliocomms "github.com/twilio/twilio-comms-go/twilio"
    client "github.com/twilio/twilio-comms-go/twilio/client"
    option "github.com/twilio/twilio-comms-go/twilio/option"
)

func do() {
    client := client.NewWithOptions(
        option.WithBasicAuth(
            "<username>",
            "<password>",
        ),
    )
    request := &twiliocomms.DeviceRegistrationsRegisterRequest{
        UserId: twiliocomms.String(
            "comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8",
        ),
        AppName: "limonade_app",
        Token: "dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh",
        Provider: twiliocomms.PushNotificationProviderFcm,
    }
    client.PushNotifications.DeviceRegistrations.Register(
        context.TODO(),
        request,
    )
}
```

```php
<?php

namespace Example;

use Twilio\TwilioComms;
use Twilio\PushNotifications\DeviceRegistrations\Requests\DeviceRegistrationsRegisterRequest;
use Twilio\Types\PushNotificationProvider;

$client = new TwilioComms(
    accountId: '<username>',
    authToken: '<password>',
);
$client->pushNotifications->deviceRegistrations->register(
    new DeviceRegistrationsRegisterRequest([
        'userId' => 'comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8',
        'appName' => 'limonade_app',
        'token' => 'dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh',
        'provider' => PushNotificationProvider::Fcm->value,
    ]),
);
```

```rb
require "twilio"

client = Twilio::Client.new(
  account_id: "<username>",
  auth_token: "<password>"
)

client.push_notifications.device_registrations.register(
  user_id: "comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8",
  app_name: "limonade_app",
  token: "dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh",
  provider: "FCM"
)
```

```bash
curl -X POST 'https://comms.twilio.com/v1/PushNotifications/DeviceRegistrations' \
--header 'Content-Type: application/json' \
--data '{
    "userId": "your_user_id",
    "appName": "your_app_name",
    "token": "your_device_token",
    "provider": "FCM"
}' \
-u $TWILIO_ACCOUNT_SID:$TWILIO_AUTH_TOKEN
```

## Fetch a Device Registration

`GET https://comms.twilio.com/v1/PushNotifications/DeviceRegistrations/{deviceRegistrationId}`

Retrieve a single Device Registration resource by making an HTTP `GET` request to the Device Registration resource URI with the Device Registration ID.

### Path parameters

```json
[{"schema":{"x-twilio-version":1,"title":"DeviceRegistrationId","description":"A reference to a Device Registration.","type":"string","pattern":"^comms_device_registration_[a-hjkmnpqrstv-z0-9]{26,34}$","example":"comms_device_registration_01h9krwprkeee8fzqspvwy6nq8","refName":"DeviceRegistrationId","modelName":""},"x-twilio-version":1,"name":"deviceRegistrationId","in":"path","required":true}]
```

### Responses

<OperationResponse responses={[{"responseCode":"200","schema":{"description":"OK","content":{"application/json":{"schema":{"x-twilio-version":1,"title":"DeviceRegistration","type":"object","description":"A registration is a collection of a User's devices registered under a single app. It is uniquely identified by the combination of the User's id and the app name. A device is a physical device or a browser that can receive push notifications. A device is uniquely identified by its app-specific unique token and the push provider identifier.","required":["id","appName","userId","devices","related"],"refName":"DeviceRegistration","modelName":"DeviceRegistration","properties":{"id":{"x-twilio-version":1,"title":"DeviceRegistrationId","description":"A reference to a Device Registration.","type":"string","pattern":"^comms_device_registration_[a-hjkmnpqrstv-z0-9]{26,34}$","example":"comms_device_registration_01h9krwprkeee8fzqspvwy6nq8","refName":"DeviceRegistrationId","modelName":""},"appName":{"type":"string","description":"The name of the `App` that the device registrations are for."},"userId":{"x-twilio-version":1,"title":"PushNotificationUserId","description":"A reference to a Push Notification User.","type":"string","pattern":"^comms_pushnotificationuser_[0-7][a-hjkmnpqrstv-z0-9]{25,34}","example":"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8","refName":"PushNotificationUserId","modelName":""},"devices":{"type":"array","minItems":1,"maxItems":50,"description":"List of devices registered in this set.","items":{"x-twilio-version":1,"title":"Device","type":"object","description":"A device is a physical device or a browser that can receive push notifications. A device is uniquely identified by its app-specific unique token and the push provider identifier.","required":["token","provider"],"refName":"Device","modelName":"Device","properties":{"token":{"type":"string","description":"Push notifications token for the device/browser."},"provider":{"x-twilio-version":1,"title":"PushNotificationProvider","description":"Push notification service provider.","type":"string","enum":["APN","FCM"],"refName":"PushNotificationProvider","modelName":"PushNotificationProvider"}}}},"related":{"description":"A list of resources that are associated with this Device Registration.","type":"array","items":{"x-twilio-version":1,"title":"RelatedResource","type":"object","description":"A reference to a related resource.","refName":"RelatedResource","modelName":"RelatedResource","properties":{"name":{"type":"string","description":"The name of the related resource.","enum":["EMAIL","MESSAGE","PUSH_NOTIFICATION","SESSION","MEDIA","SENDER","SENDER_POOL","OPERATION","ENGAGEMENT","CREDENTIAL","PUSH_NOTIFICATION_APP","PUSH_NOTIFICATION_USER","DEVICE_REGISTRATION"]},"id":{"description":"The identifier of the related resource.","type":"string"},"uri":{"description":"The path to the related resource.","type":"string"}}}}}},"examples":{"DeviceRegistrationWithTwoDevices":{"x-twilio-version":1,"summary":"Device Registration with Two Devices","value":{"lang":"json","value":"{\n  \"id\": \"comms_device_registration_qspvwy6nq801h9krwprkeee8fz\",\n  \"appName\": \"limonade_app\",\n  \"userId\": \"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\",\n  \"devices\": [\n    {\n      \"token\": \"dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh\",\n      \"provider\": \"FCM\"\n    },\n    {\n      \"token\": \"00fc13adff785122b4ad28809a3420982341241421348097878e577c991de8f0\",\n      \"provider\": \"APN\"\n    }\n  ],\n  \"related\": [\n    {\n      \"id\": \"limonade_app\",\n      \"name\": \"PUSH_NOTIFICATION_APP\",\n      \"uri\": \"https://comms.twilio.com/v1/PushNotifications/Apps/limonade_app\"\n    },\n    {\n      \"id\": \"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\",\n      \"name\": \"PUSH_NOTIFICATION_USER\",\n      \"uri\": \"https://comms.twilio.com/v1/PushNotifications/Users/comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\"\n    }\n  ]\n}","meta":"","code":"{\n  \"id\": \"comms_device_registration_qspvwy6nq801h9krwprkeee8fz\",\n  \"appName\": \"limonade_app\",\n  \"userId\": \"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\",\n  \"devices\": [\n    {\n      \"token\": \"dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh\",\n      \"provider\": \"FCM\"\n    },\n    {\n      \"token\": \"00fc13adff785122b4ad28809a3420982341241421348097878e577c991de8f0\",\n      \"provider\": \"APN\"\n    }\n  ],\n  \"related\": [\n    {\n      \"id\": \"limonade_app\",\n      \"name\": \"PUSH_NOTIFICATION_APP\",\n      \"uri\": \"https://comms.twilio.com/v1/PushNotifications/Apps/limonade_app\"\n    },\n    {\n      \"id\": \"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\",\n      \"name\": \"PUSH_NOTIFICATION_USER\",\n      \"uri\": \"https://comms.twilio.com/v1/PushNotifications/Users/comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"id\"","#7EE787"],[":","#C9D1D9"]," ",["\"comms_device_registration_qspvwy6nq801h9krwprkeee8fz\"","#A5D6FF"],[",","#C9D1D9"],"\n  ",["\"appName\"","#7EE787"],[":","#C9D1D9"]," ",["\"limonade_app\"","#A5D6FF"],[",","#C9D1D9"],"\n  ",["\"userId\"","#7EE787"],[":","#C9D1D9"]," ",["\"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\"","#A5D6FF"],[",","#C9D1D9"],"\n  ",["\"devices\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"token\"","#7EE787"],[":","#C9D1D9"]," ",["\"dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"provider\"","#7EE787"],[":","#C9D1D9"]," ",["\"FCM\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"token\"","#7EE787"],[":","#C9D1D9"]," ",["\"00fc13adff785122b4ad28809a3420982341241421348097878e577c991de8f0\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"provider\"","#7EE787"],[":","#C9D1D9"]," ",["\"APN\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["],","#C9D1D9"],"\n  ",["\"related\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"id\"","#7EE787"],[":","#C9D1D9"]," ",["\"limonade_app\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"name\"","#7EE787"],[":","#C9D1D9"]," ",["\"PUSH_NOTIFICATION_APP\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"uri\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://comms.twilio.com/v1/PushNotifications/Apps/limonade_app\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"id\"","#7EE787"],[":","#C9D1D9"]," ",["\"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"name\"","#7EE787"],[":","#C9D1D9"]," ",["\"PUSH_NOTIFICATION_USER\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"uri\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://comms.twilio.com/v1/PushNotifications/Users/comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}}}},{"responseCode":"400","schema":{"x-twilio-version":1,"description":"This error indicates that the request content was malformed or ambiguous.","content":{"application/json":{"schema":{"x-twilio-version":1,"title":"TwilioErrors","type":"object","required":["errors"],"example":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21614","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The address specified in the request is not a valid phone number.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21614\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.to[0].address\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21617","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The concatenated message text exceeds the 1600 character limit\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21617\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.content.text\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}},"refName":"TwilioErrors","modelName":"TwilioErrors","properties":{"errors":{"description":"A list of one or more Twilio API errors.","type":"array","items":{"x-twilio-version":1,"title":"TwilioError","type":"object","description":"A generic error object communicating client and server side API errors.","required":["code","message","infoUrl","context"],"example":{"code":21614,"message":"The address specified in the request is not a valid phone number.","infoUrl":"https://www.twilio.com/docs/api/errors/21614","context":"$.to[0].address"},"refName":"TwilioError","modelName":"TwilioError","properties":{"code":{"type":"integer","description":"The Twilio error code."},"message":{"type":"string","description":"A human readable message describing the error."},"infoUrl":{"type":"string","format":"uri","description":"A URL to a [Twilio error directory](https://www.twilio.com/docs/api/errors) page with more information about the error code."},"context":{"description":"A JSON path that identifies the errant field.","type":["string","null"]}}}}}},"examples":{"ResourceNotFound":{"summary":"Resource not found","value":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 20404,\n      \"message\": \"Not Found\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20404\",\n      \"context\": \"null\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 20404,\n      \"message\": \"Not Found\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20404\",\n      \"context\": \"null\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["20404","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"Not Found\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/20404\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"null\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}},"refName":"#/components/responses/Http400Response","modelName":"__components_responses_Http400Response"}},{"responseCode":"404","schema":{"x-twilio-version":1,"description":"This error indicates that the requested resource was not found.","content":{"application/json":{"schema":{"x-twilio-version":1,"title":"TwilioErrors","type":"object","required":["errors"],"example":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21614","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The address specified in the request is not a valid phone number.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21614\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.to[0].address\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21617","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The concatenated message text exceeds the 1600 character limit\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21617\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.content.text\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}},"refName":"TwilioErrors","modelName":"TwilioErrors","properties":{"errors":{"description":"A list of one or more Twilio API errors.","type":"array","items":{"x-twilio-version":1,"title":"TwilioError","type":"object","description":"A generic error object communicating client and server side API errors.","required":["code","message","infoUrl","context"],"example":{"code":21614,"message":"The address specified in the request is not a valid phone number.","infoUrl":"https://www.twilio.com/docs/api/errors/21614","context":"$.to[0].address"},"refName":"TwilioError","modelName":"TwilioError","properties":{"code":{"type":"integer","description":"The Twilio error code."},"message":{"type":"string","description":"A human readable message describing the error."},"infoUrl":{"type":"string","format":"uri","description":"A URL to a [Twilio error directory](https://www.twilio.com/docs/api/errors) page with more information about the error code."},"context":{"description":"A JSON path that identifies the errant field.","type":["string","null"]}}}}}},"examples":{"ResourceNotFound":{"summary":"404 Response","value":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 20404,\n      \"message\": \"The resource was not found.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20404\",\n      \"context\": \"null\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 20404,\n      \"message\": \"The resource was not found.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20404\",\n      \"context\": \"null\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["20404","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The resource was not found.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/20404\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"null\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}},"refName":"#/components/responses/Http404Response","modelName":"__components_responses_Http404Response"}},{"responseCode":"429","schema":{"x-twilio-version":1,"description":"This error indicates that you have sent too many requests to the API. You should retry according to the `Retry-After` response header.","content":{"application/json":{"schema":{"x-twilio-version":1,"title":"TwilioErrors","type":"object","required":["errors"],"example":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21614","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The address specified in the request is not a valid phone number.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21614\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.to[0].address\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21617","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The concatenated message text exceeds the 1600 character limit\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21617\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.content.text\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}},"refName":"TwilioErrors","modelName":"TwilioErrors","properties":{"errors":{"description":"A list of one or more Twilio API errors.","type":"array","items":{"x-twilio-version":1,"title":"TwilioError","type":"object","description":"A generic error object communicating client and server side API errors.","required":["code","message","infoUrl","context"],"example":{"code":21614,"message":"The address specified in the request is not a valid phone number.","infoUrl":"https://www.twilio.com/docs/api/errors/21614","context":"$.to[0].address"},"refName":"TwilioError","modelName":"TwilioError","properties":{"code":{"type":"integer","description":"The Twilio error code."},"message":{"type":"string","description":"A human readable message describing the error."},"infoUrl":{"type":"string","format":"uri","description":"A URL to a [Twilio error directory](https://www.twilio.com/docs/api/errors) page with more information about the error code."},"context":{"description":"A JSON path that identifies the errant field.","type":["string","null"]}}}}}},"examples":{"TooManyRequests":{"summary":"Too Many Requests","value":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 20429,\n      \"message\": \"Too many requests. Please retry according to the Retry-After response header.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20429\",\n      \"context\": \"null\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 20429,\n      \"message\": \"Too many requests. Please retry according to the Retry-After response header.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20429\",\n      \"context\": \"null\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["20429","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"Too many requests. Please retry according to the Retry-After response header.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/20429\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"null\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}},"headers":{"Retry-After":{"schema":{"type":"string"},"description":"The amount of time in seconds that the customer should wait before issuing a new request towards the API."}},"refName":"#/components/responses/Http429Response","modelName":"__components_responses_Http429Response"}},{"responseCode":"500","schema":{"x-twilio-version":1,"description":"This error indicates that the Twilio API is experiencing server-side issues. The request should not be retried.","content":{"application/json":{"schema":{"x-twilio-version":1,"title":"TwilioErrors","type":"object","required":["errors"],"example":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21614","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The address specified in the request is not a valid phone number.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21614\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.to[0].address\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21617","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The concatenated message text exceeds the 1600 character limit\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21617\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.content.text\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}},"refName":"TwilioErrors","modelName":"TwilioErrors","properties":{"errors":{"description":"A list of one or more Twilio API errors.","type":"array","items":{"x-twilio-version":1,"title":"TwilioError","type":"object","description":"A generic error object communicating client and server side API errors.","required":["code","message","infoUrl","context"],"example":{"code":21614,"message":"The address specified in the request is not a valid phone number.","infoUrl":"https://www.twilio.com/docs/api/errors/21614","context":"$.to[0].address"},"refName":"TwilioError","modelName":"TwilioError","properties":{"code":{"type":"integer","description":"The Twilio error code."},"message":{"type":"string","description":"A human readable message describing the error."},"infoUrl":{"type":"string","format":"uri","description":"A URL to a [Twilio error directory](https://www.twilio.com/docs/api/errors) page with more information about the error code."},"context":{"description":"A JSON path that identifies the errant field.","type":["string","null"]}}}}}},"examples":{"InternalServerError":{"summary":"Internal Server Error","value":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 20500,\n      \"message\": \"Internal server error.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20500\",\n      \"context\": \"null\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 20500,\n      \"message\": \"Internal server error.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20500\",\n      \"context\": \"null\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["20500","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"Internal server error.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/20500\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"null\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}},"refName":"#/components/responses/Http500Response","modelName":"__components_responses_Http500Response"}},{"responseCode":"503","schema":{"x-twilio-version":1,"description":"This error indicates that the Twilio API is temporarily unavailable.  You should retry according to the `Retry-After` response header.","content":{"application/json":{"schema":{"x-twilio-version":1,"title":"TwilioErrors","type":"object","required":["errors"],"example":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21614","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The address specified in the request is not a valid phone number.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21614\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.to[0].address\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21617","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The concatenated message text exceeds the 1600 character limit\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21617\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.content.text\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}},"refName":"TwilioErrors","modelName":"TwilioErrors","properties":{"errors":{"description":"A list of one or more Twilio API errors.","type":"array","items":{"x-twilio-version":1,"title":"TwilioError","type":"object","description":"A generic error object communicating client and server side API errors.","required":["code","message","infoUrl","context"],"example":{"code":21614,"message":"The address specified in the request is not a valid phone number.","infoUrl":"https://www.twilio.com/docs/api/errors/21614","context":"$.to[0].address"},"refName":"TwilioError","modelName":"TwilioError","properties":{"code":{"type":"integer","description":"The Twilio error code."},"message":{"type":"string","description":"A human readable message describing the error."},"infoUrl":{"type":"string","format":"uri","description":"A URL to a [Twilio error directory](https://www.twilio.com/docs/api/errors) page with more information about the error code."},"context":{"description":"A JSON path that identifies the errant field.","type":["string","null"]}}}}}},"examples":{"ServiceUnavailable":{"summary":"Service Unavailable","value":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 20503,\n      \"message\": \"Service unavailable.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20503\",\n      \"context\": \"null\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 20503,\n      \"message\": \"Service unavailable.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20503\",\n      \"context\": \"null\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["20503","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"Service unavailable.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/20503\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"null\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}},"headers":{"Retry-After":{"schema":{"type":"string"},"description":"The amount of time in seconds that the customer should wait before issuing a new request towards the API."}},"refName":"#/components/responses/Http503Response","modelName":"__components_responses_Http503Response"}}]} path="https://comms.twilio.com/v1/PushNotifications/DeviceRegistrations/{deviceRegistrationId}" method="get" specType="comms" />

Fetch a DeviceRegistration

```ts
import { TwilioClient } from "twilio-comms";

async function main() {
    const client = new TwilioClient({
        accountId: "<username>",
        authToken: "<password>",
    });
    await client.pushNotifications.deviceRegistrations.fetch("comms_device_registration_01h9krwprkeee8fzqspvwy6nq8");
}
main();
```

```py
from twilio import TwilioComms

client = TwilioComms(
    account_id="<username>",
    auth_token="<password>",
)

client.push_notifications.device_registrations.fetch(
    device_registration_id="comms_device_registration_01h9krwprkeee8fzqspvwy6nq8",
)
```

```cs
using TwilioComms;
using System.Threading.Tasks;

public partial class Examples
{
    public async Task Example() {
        var client = new TwilioCommsClient(
            accountId: "<username>",
            authToken: "<password>"
        );

        await client.PushNotifications.DeviceRegistrations.FetchAsync(
            "comms_device_registration_01h9krwprkeee8fzqspvwy6nq8"
        );
    }

}
```

```java
package com.example.usage;

import com.twilio.comms.TwilioCommsClient;

public class Example {
    public static void main(String[] args) {
        TwilioCommsClient client = TwilioCommsClient
            .builder()
            .credentials("<username>", "<password>")
            .build();

        client.pushNotifications().deviceRegistrations().fetch("comms_device_registration_01h9krwprkeee8fzqspvwy6nq8");
    }
}
```

```go
package example

import (
    context "context"

    client "github.com/twilio/twilio-comms-go/twilio/client"
    option "github.com/twilio/twilio-comms-go/twilio/option"
)

func do() {
    client := client.NewWithOptions(
        option.WithBasicAuth(
            "<username>",
            "<password>",
        ),
    )
    client.PushNotifications.DeviceRegistrations.Fetch(
        context.TODO(),
        "comms_device_registration_01h9krwprkeee8fzqspvwy6nq8",
    )
}
```

```php
<?php

namespace Example;

use Twilio\TwilioComms;

$client = new TwilioComms(
    accountId: '<username>',
    authToken: '<password>',
);
$client->pushNotifications->deviceRegistrations->fetch(
    'comms_device_registration_01h9krwprkeee8fzqspvwy6nq8',
);
```

```rb
require "twilio"

client = Twilio::Client.new(
  account_id: "<username>",
  auth_token: "<password>"
)

client.push_notifications.device_registrations.fetch(device_registration_id: "comms_device_registration_01h9krwprkeee8fzqspvwy6nq8")
```

```bash
curl 'https://comms.twilio.com/v1/PushNotifications/DeviceRegistrations/{deviceRegistrationId}' \
-u $TWILIO_ACCOUNT_SID:$TWILIO_AUTH_TOKEN
```

## List Device Registrations

`GET https://comms.twilio.com/v1/PushNotifications/DeviceRegistrations`

Returns a list of Device Registrations. The `userId` query parameter is required. You can optionally filter by `appName`.

### Query parameters

```json
[{"in":"query","name":"userId","required":true,"description":"Filter Device Registrations by `User.id` to retrieve only registrations for that User.","schema":{"x-twilio-version":1,"title":"PushNotificationUserId","description":"A reference to a Push Notification User.","type":"string","pattern":"^comms_pushnotificationuser_[0-7][a-hjkmnpqrstv-z0-9]{25,34}","example":"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8","refName":"PushNotificationUserId","modelName":""}},{"in":"query","name":"appName","description":"Filter Device Registrations by their `appName`. Must be accompanied by the `userId` query parameter.","schema":{"x-twilio-version":1,"title":"PushNotificationAppName","description":"The name of the Push Notification `App`.","type":"string","pattern":"^[a-z0-9_]+$","minLength":1,"maxLength":64,"refName":"PushNotificationAppName","modelName":""}},{"in":"query","name":"pageToken","description":"The token to retrieve the next page of results.","schema":{"x-twilio-version":1,"description":"The token that identifies the page of resources to fetch.","title":"PageToken","type":"string","refName":"PageToken","modelName":""}},{"in":"query","name":"pageSize","description":"The number of resources to return in a page.","schema":{"x-twilio-version":1,"description":"Total number of items returned in a single page, the minimum is 1 and maximum is 1000. Default is 50.","title":"PageSize","type":"integer","minimum":1,"maximum":1000,"default":50,"example":50,"refName":"PageSize","modelName":""}}]
```

### Responses

<OperationResponse responses={[{"responseCode":"200","schema":{"description":"OK","content":{"application/json":{"schema":{"title":"ListDeviceRegistrationsResponse","type":"object","required":["deviceRegistrations","pagination"],"properties":{"deviceRegistrations":{"type":"array","description":"List of Device Registrations.","items":{"x-twilio-version":1,"title":"DeviceRegistration","type":"object","description":"A registration is a collection of a User's devices registered under a single app. It is uniquely identified by the combination of the User's id and the app name. A device is a physical device or a browser that can receive push notifications. A device is uniquely identified by its app-specific unique token and the push provider identifier.","required":["id","appName","userId","devices","related"],"refName":"DeviceRegistration","modelName":"DeviceRegistration","properties":{"id":{"x-twilio-version":1,"title":"DeviceRegistrationId","description":"A reference to a Device Registration.","type":"string","pattern":"^comms_device_registration_[a-hjkmnpqrstv-z0-9]{26,34}$","example":"comms_device_registration_01h9krwprkeee8fzqspvwy6nq8","refName":"DeviceRegistrationId","modelName":""},"appName":{"type":"string","description":"The name of the `App` that the device registrations are for."},"userId":{"x-twilio-version":1,"title":"PushNotificationUserId","description":"A reference to a Push Notification User.","type":"string","pattern":"^comms_pushnotificationuser_[0-7][a-hjkmnpqrstv-z0-9]{25,34}","example":"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8","refName":"PushNotificationUserId","modelName":""},"devices":{"type":"array","minItems":1,"maxItems":50,"description":"List of devices registered in this set.","items":{"x-twilio-version":1,"title":"Device","type":"object","description":"A device is a physical device or a browser that can receive push notifications. A device is uniquely identified by its app-specific unique token and the push provider identifier.","required":["token","provider"],"refName":"Device","modelName":"Device","properties":{"token":{"type":"string","description":"Push notifications token for the device/browser."},"provider":{"x-twilio-version":1,"title":"PushNotificationProvider","description":"Push notification service provider.","type":"string","enum":["APN","FCM"],"refName":"PushNotificationProvider","modelName":"PushNotificationProvider"}}}},"related":{"description":"A list of resources that are associated with this Device Registration.","type":"array","items":{"x-twilio-version":1,"title":"RelatedResource","type":"object","description":"A reference to a related resource.","refName":"RelatedResource","modelName":"RelatedResource","properties":{"name":{"type":"string","description":"The name of the related resource.","enum":["EMAIL","MESSAGE","PUSH_NOTIFICATION","SESSION","MEDIA","SENDER","SENDER_POOL","OPERATION","ENGAGEMENT","CREDENTIAL","PUSH_NOTIFICATION_APP","PUSH_NOTIFICATION_USER","DEVICE_REGISTRATION"]},"id":{"description":"The identifier of the related resource.","type":"string"},"uri":{"description":"The path to the related resource.","type":"string"}}}}}}},"pagination":{"x-twilio-version":1,"title":"PaginationMetadata","description":"Metadata for paginated results. \nThis object contains two tokens to navigate through paginated results. \n- Use `next` to retrieve the 'next' page in the result list.\n- Use `self` to retrieve the same page of the result list again. \n- Supply the token in the `pageToken` query param.","type":"object","required":["next","self"],"refName":"PaginationMetadata","modelName":"PaginationMetadata","properties":{"next":{"description":"Token for the next page of results. \nSupply the token in the `pageToken` query param.","type":["string","null"]},"self":{"description":"Token for the current page of results. \nSupply the token in the `pageToken` query param.","type":"string"}}}}},"examples":{"ListOfDeviceRegistrations":{"x-twilio-version":1,"summary":"List of Device Registrations","value":{"lang":"json","value":"{\n  \"deviceRegistrations\": [\n    {\n      \"id\": \"comms_device_registration_qspvwy6nq801h9krwprkeee8fz\",\n      \"appName\": \"limonade_app\",\n      \"userId\": \"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\",\n      \"devices\": [\n        {\n          \"token\": \"dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh\",\n          \"provider\": \"FCM\"\n        },\n        {\n          \"token\": \"00fc13adff785122b4ad28809a3420982341241421348097878e577c991de8f0\",\n          \"provider\": \"APN\"\n        }\n      ],\n      \"related\": [\n        {\n          \"id\": \"limonade_app\",\n          \"name\": \"PUSH_NOTIFICATION_APP\",\n          \"uri\": \"https://comms.twilio.com/v1/PushNotifications/Apps/limonade_app\"\n        },\n        {\n          \"id\": \"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\",\n          \"name\": \"PUSH_NOTIFICATION_USER\",\n          \"uri\": \"https://comms.twilio.com/v1/PushNotifications/Users/comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\"\n        }\n      ]\n    }\n  ],\n  \"pagination\": {\n    \"next\": null,\n    \"self\": \"eyJTSyI6IkEjMDFqbmVoYm5xYWZmNDlrazUxZHA1bmN5bXciLCJTSzEiOiJBI2FjdGl2YXRlZCMyMDI1LTAzLTAzVDE3OjM3OjQ3WiMwMWpuZWhibnFhZmY0OWtrNTFkcDVuY3ltdyIsIlBLIjoiQyNBQzYwMzg4ODJiZDY5ZWIyNGM4YzU4ZGI5NjE4NjE3OTE4I0EifQ==\"\n  }\n}","meta":"","code":"{\n  \"deviceRegistrations\": [\n    {\n      \"id\": \"comms_device_registration_qspvwy6nq801h9krwprkeee8fz\",\n      \"appName\": \"limonade_app\",\n      \"userId\": \"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\",\n      \"devices\": [\n        {\n          \"token\": \"dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh\",\n          \"provider\": \"FCM\"\n        },\n        {\n          \"token\": \"00fc13adff785122b4ad28809a3420982341241421348097878e577c991de8f0\",\n          \"provider\": \"APN\"\n        }\n      ],\n      \"related\": [\n        {\n          \"id\": \"limonade_app\",\n          \"name\": \"PUSH_NOTIFICATION_APP\",\n          \"uri\": \"https://comms.twilio.com/v1/PushNotifications/Apps/limonade_app\"\n        },\n        {\n          \"id\": \"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\",\n          \"name\": \"PUSH_NOTIFICATION_USER\",\n          \"uri\": \"https://comms.twilio.com/v1/PushNotifications/Users/comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\"\n        }\n      ]\n    }\n  ],\n  \"pagination\": {\n    \"next\": null,\n    \"self\": \"eyJTSyI6IkEjMDFqbmVoYm5xYWZmNDlrazUxZHA1bmN5bXciLCJTSzEiOiJBI2FjdGl2YXRlZCMyMDI1LTAzLTAzVDE3OjM3OjQ3WiMwMWpuZWhibnFhZmY0OWtrNTFkcDVuY3ltdyIsIlBLIjoiQyNBQzYwMzg4ODJiZDY5ZWIyNGM4YzU4ZGI5NjE4NjE3OTE4I0EifQ==\"\n  }\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"deviceRegistrations\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"id\"","#7EE787"],[":","#C9D1D9"]," ",["\"comms_device_registration_qspvwy6nq801h9krwprkeee8fz\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"appName\"","#7EE787"],[":","#C9D1D9"]," ",["\"limonade_app\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"userId\"","#7EE787"],[":","#C9D1D9"]," ",["\"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"devices\"","#7EE787"],[": [","#C9D1D9"],"\n        ",["{","#C9D1D9"],"\n          ",["\"token\"","#7EE787"],[":","#C9D1D9"]," ",["\"dqWD7WEC83K41WHyufTS7:APA91bFcrVaOLqKeJfSiEutJXX2Tr9wN_tYOwYd8rFA6mYUMBFqdz9n6k3v5EpFA_ukXD89hGqG3OarzbVfdjGnLOIAQfwbQcqJkjQWMrhwElrtU1y3JLDPfnjc0eTJLxzhyYvDFopEh\"","#A5D6FF"],[",","#C9D1D9"],"\n          ",["\"provider\"","#7EE787"],[":","#C9D1D9"]," ",["\"FCM\"","#A5D6FF"],"\n        ",["},","#C9D1D9"],"\n        ",["{","#C9D1D9"],"\n          ",["\"token\"","#7EE787"],[":","#C9D1D9"]," ",["\"00fc13adff785122b4ad28809a3420982341241421348097878e577c991de8f0\"","#A5D6FF"],[",","#C9D1D9"],"\n          ",["\"provider\"","#7EE787"],[":","#C9D1D9"]," ",["\"APN\"","#A5D6FF"],"\n        ",["}","#C9D1D9"],"\n      ",["],","#C9D1D9"],"\n      ",["\"related\"","#7EE787"],[": [","#C9D1D9"],"\n        ",["{","#C9D1D9"],"\n          ",["\"id\"","#7EE787"],[":","#C9D1D9"]," ",["\"limonade_app\"","#A5D6FF"],[",","#C9D1D9"],"\n          ",["\"name\"","#7EE787"],[":","#C9D1D9"]," ",["\"PUSH_NOTIFICATION_APP\"","#A5D6FF"],[",","#C9D1D9"],"\n          ",["\"uri\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://comms.twilio.com/v1/PushNotifications/Apps/limonade_app\"","#A5D6FF"],"\n        ",["},","#C9D1D9"],"\n        ",["{","#C9D1D9"],"\n          ",["\"id\"","#7EE787"],[":","#C9D1D9"]," ",["\"comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\"","#A5D6FF"],[",","#C9D1D9"],"\n          ",["\"name\"","#7EE787"],[":","#C9D1D9"]," ",["\"PUSH_NOTIFICATION_USER\"","#A5D6FF"],[",","#C9D1D9"],"\n          ",["\"uri\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://comms.twilio.com/v1/PushNotifications/Users/comms_pushnotificationuser_01h9krwprkeee8fzqspvwy6nq8\"","#A5D6FF"],"\n        ",["}","#C9D1D9"],"\n      ",["]","#C9D1D9"],"\n    ",["}","#C9D1D9"],"\n  ",["],","#C9D1D9"],"\n  ",["\"pagination\"","#7EE787"],[": {","#C9D1D9"],"\n    ",["\"next\"","#7EE787"],[":","#C9D1D9"]," ",["null","#79C0FF"],[",","#C9D1D9"],"\n    ",["\"self\"","#7EE787"],[":","#C9D1D9"]," ",["\"eyJTSyI6IkEjMDFqbmVoYm5xYWZmNDlrazUxZHA1bmN5bXciLCJTSzEiOiJBI2FjdGl2YXRlZCMyMDI1LTAzLTAzVDE3OjM3OjQ3WiMwMWpuZWhibnFhZmY0OWtrNTFkcDVuY3ltdyIsIlBLIjoiQyNBQzYwMzg4ODJiZDY5ZWIyNGM4YzU4ZGI5NjE4NjE3OTE4I0EifQ==\"","#A5D6FF"],"\n  ",["}","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}}}},{"responseCode":"400","schema":{"x-twilio-version":1,"description":"This error indicates that the request content was malformed or ambiguous.","content":{"application/json":{"schema":{"x-twilio-version":1,"title":"TwilioErrors","type":"object","required":["errors"],"example":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21614","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The address specified in the request is not a valid phone number.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21614\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.to[0].address\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21617","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The concatenated message text exceeds the 1600 character limit\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21617\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.content.text\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}},"refName":"TwilioErrors","modelName":"TwilioErrors","properties":{"errors":{"description":"A list of one or more Twilio API errors.","type":"array","items":{"x-twilio-version":1,"title":"TwilioError","type":"object","description":"A generic error object communicating client and server side API errors.","required":["code","message","infoUrl","context"],"example":{"code":21614,"message":"The address specified in the request is not a valid phone number.","infoUrl":"https://www.twilio.com/docs/api/errors/21614","context":"$.to[0].address"},"refName":"TwilioError","modelName":"TwilioError","properties":{"code":{"type":"integer","description":"The Twilio error code."},"message":{"type":"string","description":"A human readable message describing the error."},"infoUrl":{"type":"string","format":"uri","description":"A URL to a [Twilio error directory](https://www.twilio.com/docs/api/errors) page with more information about the error code."},"context":{"description":"A JSON path that identifies the errant field.","type":["string","null"]}}}}}},"examples":{"ResourceNotFound":{"summary":"Resource not found","value":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 20404,\n      \"message\": \"Not Found\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20404\",\n      \"context\": \"null\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 20404,\n      \"message\": \"Not Found\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20404\",\n      \"context\": \"null\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["20404","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"Not Found\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/20404\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"null\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}},"refName":"#/components/responses/Http400Response","modelName":"__components_responses_Http400Response"}},{"responseCode":"429","schema":{"x-twilio-version":1,"description":"This error indicates that you have sent too many requests to the API. You should retry according to the `Retry-After` response header.","content":{"application/json":{"schema":{"x-twilio-version":1,"title":"TwilioErrors","type":"object","required":["errors"],"example":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21614","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The address specified in the request is not a valid phone number.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21614\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.to[0].address\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21617","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The concatenated message text exceeds the 1600 character limit\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21617\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.content.text\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}},"refName":"TwilioErrors","modelName":"TwilioErrors","properties":{"errors":{"description":"A list of one or more Twilio API errors.","type":"array","items":{"x-twilio-version":1,"title":"TwilioError","type":"object","description":"A generic error object communicating client and server side API errors.","required":["code","message","infoUrl","context"],"example":{"code":21614,"message":"The address specified in the request is not a valid phone number.","infoUrl":"https://www.twilio.com/docs/api/errors/21614","context":"$.to[0].address"},"refName":"TwilioError","modelName":"TwilioError","properties":{"code":{"type":"integer","description":"The Twilio error code."},"message":{"type":"string","description":"A human readable message describing the error."},"infoUrl":{"type":"string","format":"uri","description":"A URL to a [Twilio error directory](https://www.twilio.com/docs/api/errors) page with more information about the error code."},"context":{"description":"A JSON path that identifies the errant field.","type":["string","null"]}}}}}},"examples":{"TooManyRequests":{"summary":"Too Many Requests","value":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 20429,\n      \"message\": \"Too many requests. Please retry according to the Retry-After response header.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20429\",\n      \"context\": \"null\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 20429,\n      \"message\": \"Too many requests. Please retry according to the Retry-After response header.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20429\",\n      \"context\": \"null\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["20429","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"Too many requests. Please retry according to the Retry-After response header.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/20429\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"null\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}}}}}},"headers":{"Retry-After":{"schema":{"type":"string"},"description":"The amount of time in seconds that the customer should wait before issuing a new request towards the API."}},"refName":"#/components/responses/Http429Response","modelName":"__components_responses_Http429Response"}},{"responseCode":"500","schema":{"x-twilio-version":1,"description":"This error indicates that the Twilio API is experiencing server-side issues. The request should not be retried.","content":{"application/json":{"schema":{"x-twilio-version":1,"title":"TwilioErrors","type":"object","required":["errors"],"example":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 21614,\n      \"message\": \"The address specified in the request is not a valid phone number.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21614\",\n      \"context\": \"$.to[0].address\"\n    },\n    {\n      \"code\": 21617,\n      \"message\": \"The concatenated message text exceeds the 1600 character limit\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/21617\",\n      \"context\": \"$.content.text\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21614","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The address specified in the request is not a valid phone number.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21614\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.to[0].address\"","#A5D6FF"],"\n    ",["},","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["21617","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"The concatenated message text exceeds the 1600 character limit\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/21617\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"$.content.text\"","#A5D6FF"],"\n    ",["}","#C9D1D9"],"\n  ",["]","#C9D1D9"],"\n",["}","#C9D1D9"]],"annotations":[],"themeName":"github-dark","style":{"color":"#c9d1d9","background":"#0d1117"}},"refName":"TwilioErrors","modelName":"TwilioErrors","properties":{"errors":{"description":"A list of one or more Twilio API errors.","type":"array","items":{"x-twilio-version":1,"title":"TwilioError","type":"object","description":"A generic error object communicating client and server side API errors.","required":["code","message","infoUrl","context"],"example":{"code":21614,"message":"The address specified in the request is not a valid phone number.","infoUrl":"https://www.twilio.com/docs/api/errors/21614","context":"$.to[0].address"},"refName":"TwilioError","modelName":"TwilioError","properties":{"code":{"type":"integer","description":"The Twilio error code."},"message":{"type":"string","description":"A human readable message describing the error."},"infoUrl":{"type":"string","format":"uri","description":"A URL to a [Twilio error directory](https://www.twilio.com/docs/api/errors) page with more information about the error code."},"context":{"description":"A JSON path that identifies the errant field.","type":["string","null"]}}}}}},"examples":{"InternalServerError":{"summary":"Internal Server Error","value":{"lang":"json","value":"{\n  \"errors\": [\n    {\n      \"code\": 20500,\n      \"message\": \"Internal server error.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20500\",\n      \"context\": \"null\"\n    }\n  ]\n}","meta":"","code":"{\n  \"errors\": [\n    {\n      \"code\": 20500,\n      \"message\": \"Internal server error.\",\n      \"infoUrl\": \"https://www.twilio.com/docs/api/errors/20500\",\n      \"context\": \"null\"\n    }\n  ]\n}","tokens":[["{","#C9D1D9"],"\n  ",["\"errors\"","#7EE787"],[": [","#C9D1D9"],"\n    ",["{","#C9D1D9"],"\n      ",["\"code\"","#7EE787"],[":","#C9D1D9"]," ",["20500","#79C0FF"],[",","#C9D1D9"],"\n      ",["\"message\"","#7EE787"],[":","#C9D1D9"]," ",["\"Internal server error.\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"infoUrl\"","#7EE787"],[":","#C9D1D9"]," ",["\"https://www.twilio.com/docs/api/errors/20500\"","#A5D6FF"],[",","#C9D1D9"],"\n      ",["\"context\"","#7EE787"],[":","#C9D1D9"]," ",["\"null\"","#A5D6FF"],"\n    ",["}
[...]
